@use "sass:math";

#projects {
  padding: 48px 32px 128px;

  h3 {
    margin: 0 0 64px;

    font-family: $f-title;
    font-weight: 400;
    font-size: 16px;

    text-transform: uppercase;
    text-align: center;
  }

  $border-width: 2px;
  $border: solid $border-width hsla(221, 86%, 72%, 0.35);

  /*
   * Old cover represantation
   */

  // Strips units from a variable
  @function strip-unit($number) {
    @return calc($number / ($number * 0 + 1px));
  }

  $nav__max-item-width: 96px;
  $nav__padding: 18px;
  $projects__gap: 8px;

  $black: hsl(0, 0%, 0%);
  $white: hsl(0, 0%, 100%);

  $gray-50: hsl(0, 0%, 97%);
  $gray-100: hsl(0, 0%, 95%);
  $gray-200: hsl(0, 0%, 90%);
  $gray-300: hsl(0, 0%, 75%);
  $gray-400: hsl(0, 0%, 50%);
  $gray-500: hsl(0, 0%, 40%);
  $gray-600: hsl(0, 0%, 30%);
  $gray-700: hsl(0, 0%, 18%);
  $gray-800: hsl(0, 0%, 9%);
  $gray-900: hsl(0, 0%, 5%);

  $accent-400: hsl(355, 100%, 50%);
  $accent-500: hsl(345, 100%, 42%);
  $accent-600: hsl(345, 100%, 30%);
  $accent-700: hsl(345, 100%, 18%);
  $accent-800: hsl(345, 100%, 9%);
  $accent-900: hsl(345, 100%, 5%);

  .projects {
    margin: auto;
    display: grid;
    grid-template-columns: repeat(auto-fit, minmax(128px, auto));
    grid-auto-flow: dense;
    justify-content: center;
    max-width: 1024px;
    gap: $projects__gap;

    // @media (min-width: #{4 * $nav__max-item-width + 2 * $nav__padding + 64px}) { // + 2px or sth
    @media (min-width: 490px) {
      grid-template-columns: repeat(auto-fit, minmax(200px, auto));
    }
  }

  .cover {
    

    position: relative;

    display: block;

    // background-color: $accent-700;
    border: $border;
    border-radius: 2px;

    img {
      display: block;
      max-width: 100%;

      border-radius: inherit;
    }

    &__caption {
      position: absolute;
      top: 0;
      left: 0;

      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      gap: 4px;
      width: 100%;
      height: 100%;

      // background-color: transparentize($accent-700, 0.9);
      border-radius: inherit;
      opacity: 0;

      transition: opacity 0.2s ease-out;

      h3,
      h4 {
        margin: 0;
        max-width: calc(100% - 8px);

        color: $gray-50;
        white-space: nowrap;
        text-overflow: ellipsis;
        overflow: hidden;
      }

      h4 {
        text-transform: uppercase;
      }
    }

    &:hover &__caption {
      opacity: 1;
    }

    &--selected {
      border-bottom-left-radius: 0;
      border-bottom-right-radius: 0;
      transform: translateY(-2px);

      // // Extend below + left corner
      // &:before {
      //   content: "";
      //   position: absolute;
      //   bottom: -$projects__gap;
      //   left: -$projects__gap;

      //   width: calc(100% + #{$projects__gap});
      //   height: $projects__gap;

      //   background-color: inherit;

      //   // Path looks sth like this:
      //   //   ┌─────┄
      //   // ┌─╯
      //   // │
      //   // └───────┄
      //   // Bezier is calculated to be ¼ circle: SIZE×4×(√(2)-1)÷3
      //   $s: strip-unit($projects__gap);
      //   clip-path: path(
      //     "M 9999 0 l -#{9999 - $s} 0 c 0 #{$s * 0.55228475} -#{$s - $s * 0.55228475} #{$s} -#{$s} #{$s} l 0 10 l 9999 0 l 0 -#{$s + 10} Z"
      //   );
      // }

      // // Right corner
      // &:after {
      //   content: "";
      //   position: absolute;
      //   bottom: -$projects__gap;
      //   right: -$projects__gap;

      //   width: $projects__gap;
      //   height: $projects__gap;

      //   background-color: inherit;

      //   // Path from :before, but mirrored (Rectangle is on -x)
      //   $s: strip-unit($projects__gap);
      //   clip-path: path(
      //     "M 0 0 c 0 #{$s * 0.55228475} #{$s - $s * 0.55228475} #{$s} #{$s} #{$s} l 0 10 l -9999 0 l 0 -#{$s + 10} l #{9999 - $s} 0 Z"
      //   );
      // }
    }
  }

  .project {
    grid-column: 1 / -1;
    position: relative;
    z-index: 2;

    display: grid;
    padding: 24px;

    color: $gray-50;

    background-color: hsla(0, 0%, 3%, 0.7);
    backdrop-filter: blur(16px);
    border: $border;
    border-radius: $border;

    // &:after {
    //   content: "";
    //   position: absolute;
    //   top: 0;
    //   left: 0;
    //   z-index: -2;

    //   width: 200vw;
    //   height: 100%;

    //   background-color: inherit;

    //   transform: translateX(-25%);
    // }

    &__heading {
      margin: 0;
      font-size: 18px;

      a {
        color: inherit;
        text-decoration: none;
        text-underline-offset: 2px;

        &:hover * {
          color: $gray-50;
          transition: all 0.2s ease-out;
        }
      }

      &__artist {
        color: hsl(129, 8%, 75%);
      }

      &__ext {
        display: none;
        padding-left: 4px;

        font-size: 11pt;
        font-weight: 400;
        vertical-align: super;
      }
    }

    &__credits {
      p {
        margin: 12px 0;
      }

      a {
        color: inherit;
        opacity: 0.5;

        &:hover,
        &:focus {
          color: inherit;
          opacity: 1;
        }
      }
    }

    &__video {
      width: 100%;
      height: calc(9 * (100vw - 48px) / 16);

      @media (min-width: #{4 * $nav__max-item-width + 2 * $nav__padding + 64px}) {
        height: calc(9 * (100vw - 64px) / 16);
      }

      @media (min-width: #{5 * $nav__max-item-width + 2 * $nav__padding + 128px}) {
        height: calc(9 * (100vw - 128px) / 16);
      }
    }

    @media (min-width: 800px) {
      grid-template-columns: 320px 1fr;
      column-gap: 24px;

      &__video {
        grid-column: 1;
        grid-row: 1 / 3;

        height: 180px;
      }
    }
  }

  // .carousel {
  //   display: flex;
  //   align-items: center;
  //   gap: 8px;

  //   .forward,
  //   .back {
  //     color: hsla(221, 53%, 59%, 0.35);
  //     cursor: pointer;
  //   }

  //   &-items {
  //     $border-width: 2px;
  //     $border: solid $border-width hsla(221, 53%, 59%, 0.35);

  //     max-width: 256px;
  //     flex-shrink: 1;

  //     img {
  //       display: block;
  //       width: calc(100% - #{2 * $border-width});

  //       background-color: hsla(0, 0%, 3%, 0.7);
  //       backdrop-filter: blur(16px);
  //       border: $border;
  //       border-radius: 2px;
  //     }
  //   }

  //   @media screen and (min-width: 425px) {
  //     gap: 16px;

  //     .forward,
  //     .back {
  //       font-size: 36px;
  //     }
  //   }
  // }
}
